uniform mat4 u_m44ModelViewProjection;

uniform vec3 u_v3EyePos;


varying vec4 v_v4Colour;
uniform vec4 u_v4Color;


attribute vec4 a_v4Position;
attribute vec2 a_v2TexCoord;

uniform mat3 u_m33ModelRotation;

attribute highp vec3 a_v3MatrixX;
attribute highp vec3 a_v3MatrixY;
attribute highp vec3 a_v3MatrixZ;

varying vec2 v_v2TexCoord;

#ifdef CUBE_MAP
varying highp vec3 v_v3MatrixX;
varying highp vec3 v_v3MatrixY;
varying highp vec3 v_v3MatrixZ;
#else
uniform vec3 u_v3LightDir;
varying highp vec3 v_v3Light_Transformed;
varying vec3 v_v3Up;
#endif

varying vec3 v_v3ViewDir;


void main() 
{
	vec4 v4Position = a_v4Position;
	v4Position.w = 1.0;

	v_v2TexCoord = a_v2TexCoord;
		
    vec3 v3ViewDir = v4Position.xyz - u_v3EyePos;

	
#ifdef CUBE_MAP
	highp vec3 v3MatrixX = u_m33ModelRotation*a_v3MatrixX;
    highp vec3 v3MatrixY = u_m33ModelRotation*a_v3MatrixY;
  	highp vec3 v3MatrixZ = u_m33ModelRotation*a_v3MatrixZ;
	v_v3MatrixX = vec3(v3MatrixX.x, v3MatrixY.x, v3MatrixZ.x);
	v_v3MatrixY = vec3(v3MatrixX.y, v3MatrixY.y, v3MatrixZ.y);
	v_v3MatrixZ = vec3(v3MatrixX.z, v3MatrixY.z, v3MatrixZ.z);

	v_v3ViewDir = u_m33ModelRotation * v3ViewDir;
#else
	highp vec3 v3MatrixX = u_m33ModelRotation*a_v3MatrixX;
    highp vec3 v3MatrixY = u_m33ModelRotation*a_v3MatrixY;
  	highp vec3 v3MatrixZ = u_m33ModelRotation*a_v3MatrixZ;
	
	v_v3Light_Transformed.x = dot(u_v3LightDir, v3MatrixX);
	v_v3Light_Transformed.y = dot(u_v3LightDir, v3MatrixY);
	v_v3Light_Transformed.z = dot(u_v3LightDir, v3MatrixZ);	
    
	v_v3ViewDir.x = dot(v3ViewDir, a_v3MatrixX);
	v_v3ViewDir.y = dot(v3ViewDir, a_v3MatrixY);
	v_v3ViewDir.z = dot(v3ViewDir, a_v3MatrixZ);

	v_v3Up.x = v3MatrixX.y;
	v_v3Up.y = v3MatrixY.y;
	v_v3Up.z = v3MatrixZ.y;  
#endif


    

	v_v4Colour = u_v4Color;

    
	gl_Position = u_m44ModelViewProjection * v4Position;

	if (gl_Position.z < 0.0)
		gl_Position.z = 0.0;
	if (gl_Position.w < 1.1)
		gl_Position.w = 1.1;



	
}
